/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.world.classic.worldgen;

import java.util.Random;

import net.minecraft.init.Blocks;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.gen.feature.WorldGenerator;

import static net.dries007.tfc.world.classic.ChunkGenTFC.FRESH_WATER;

public class WorldGenWaterlilyTFC extends WorldGenerator
{
    @Override
    public boolean func_180709_b(final World worldIn, final Random rand, final BlockPos position)
    {
        for (int i = 0; i < 10; ++i)
        {
            final BlockPos p2 = position.func_177982_a(rand.nextInt(8) - rand.nextInt(8),
                rand.nextInt(4) - rand.nextInt(4),
                rand.nextInt(8) - rand.nextInt(8));

            if (worldIn.func_175623_d(p2) && Blocks.field_150392_bi.func_176196_c(worldIn, p2) &&
                worldIn.func_180495_p(p2.func_177982_a(0, -1, 0)) == FRESH_WATER &&
                worldIn.func_180495_p(p2.func_177982_a(0, -2, 0)) != FRESH_WATER) // todo: make this a little less harsh
            {
                worldIn.func_180501_a(p2, Blocks.field_150392_bi.func_176223_P(), 0x02);
            }
        }

        return true;
    }
}
